<?php
add_action( 'widgets_init', 'register_widget1' );
function register_widget1() {
    register_widget( 'Widget1' );
}

class Widget1 extends WP_Widget {

	var $image_field = 'image';

	function Widget1() {
		$widget_ops = array( 'classname' => 'widget1', 'description' => __('A custom widget') );

		$control_ops = array( 'width' => 300, 'height' => 350, 'id_base' => 'widget1' );

		$this->WP_Widget( 'widget1', __('Custom Widget 1'), $widget_ops, $control_ops );
	}

	function widget( $args, $instance ) {
		extract( $args );

		//Our variables from the widget settings.
		$image_id   = $instance[$this->image_field];
		$image      = new WidgetImageField( $this, $image_id );

		$title 		= apply_filters('widget_title', $instance['title'] );
		$content 	= $instance['content'];
		$link 		= $instance['link'];

		echo $before_widget;?>
		<div class="box style1">
			<a class="img" href="<?php echo $link;?>"><img class="pie rounded" src="<?php echo $image->get_image_src('full'); ?>" alt="" /></a>
			<a class="title" href="<?php echo $link;?>"><?php echo $title; ?></a>
			<div class="box-content"><?php echo $content; ?></div>
			<a href="<?php echo $link;?>">View map</a>
		</div>

		<?php echo $after_widget;
	}

	//Update the widget

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;

		//Strip tags from title and name to remove HTML
		$instance[$this->image_field] = intval( strip_tags( $new_instance[$this->image_field] ) );
		$instance['title'] 	= strip_tags($new_instance['title']);
		$instance['content']= $new_instance['content'];
		$instance['link'] 	= strip_tags($new_instance['link']);

		return $instance;
	}


	function form( $instance ) {

		//Set up some default widget settings.
		$defaults = array( 'title' => __(''), 'name' => __(''), 'show_info' => true );

		$image_id   = esc_attr( isset( $instance[$this->image_field] ) ? $instance[$this->image_field] : 0 );
		$image      = new WidgetImageField( $this, $image_id );

		$instance = wp_parse_args( (array) $instance, $defaults ); ?>


		<p>
            <label><?php _e( 'Image:' ); ?></label>
            <?php echo $image->get_widget_field(); ?>
        </p>

		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('Title:'); ?></label>
			<input type="text" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $instance['title']; ?>" class="widefat" />
		</p>

		<p>
			<label for="<?php echo $this->get_field_id( 'content' ); ?>"><?php _e('Content:'); ?></label>
			<textarea rows="10" cols="26" id="<?php echo $this->get_field_id( 'content' ); ?>" name="<?php echo $this->get_field_name( 'content' ); ?>" class="widefat"><?php echo $instance['content']; ?></textarea>
		</p>

		<p>
			<label for="<?php echo $this->get_field_id( 'link' ); ?>"><?php _e('Link:'); ?></label>
			<input type="text" id="<?php echo $this->get_field_id( 'link' ); ?>" name="<?php echo $this->get_field_name( 'link' ); ?>" value="<?php echo $instance['link']; ?>" class="widefat" />
		</p>

	<?php
	}
}